' (C) Copyright wellCAM CCS Lublin, 1998
'
' MAKRO 1302.MCR
' PN-ISO 1302 - Oznaczanie struktury geometrycznej powierzchni
'
' Historia zmian:
' Data      Kto                 Co
' ========  ==================  ======================================
' 12.03.98  wellCAM             Pierwsza wersja
' 24.04.98  Doycki Adam       Tablica wartoci, drobne poprawki w
'                               pozycjonowaniu tekstu
'

Option Explicit

Dim Doc As Object
Dim dwg As Object
Dim txt1 As String
Dim txt2 As String

Dim txtBeaZug As String
Dim txtFerVer As String
Dim txtBezStr As String

Dim optMatWeg As Boolean
Dim optNotBea As Boolean
Dim optUpDwn As Boolean
Dim maxLen As Integer

' procedura rysuje symbol o podanych parametrach
Private Sub DrawSymbol(dwg As Object, ox As Single, oy As Single)
	Dim chh As Single
	Dim chb As Single
	Dim x As Single
	Dim y As Single
	Dim hgt As Double, wdt As Double, agl As Double
	Dim jst As Integer, slt As Integer

	dwg.GetTextParameters hgt, wdt, agl, jst, slt
	dwg.SetTextParameters 3.5, 2.5, 0, 1, slt

	chh = 3.5 / 10
	chb = 2.5 
	dwg.SetPointORD(ox, oy) ' punkt orientacyjny obiektu

	x = ox
	y = oy

	maxLen = 0
	If Len(txtFerVer) > maxLen Then maxLen = Len(txtFerVer)
	If Len(txtBezStr) > maxLen Then maxLen = Len(txtBezStr)
	
	If optUpDwn Then
		dwg.AddLine x-8*chh,y-14*chh,x,y,8,-1
		dwg.AddLine x+16*chh,y-28*chh,x,y,8,-1
		
		dwg.AddText x+14*chh,y-13*chh,txt2,8,-1
		dwg.AddText x+(5*chh) - (Len(txt1)*chb),y-26*chh,txt1,8,-1
		dwg.AddText x-(12*chh) - (Len(txtBeaZug)*chb),y-13*chh,txtBeaZug,8,-1
		dwg.AddText x+16*chh,y-25*chh,txtFerVer,8,-1
		dwg.AddText x+16*chh,y-40*chh,txtBezStr,8,-1
		
		If maxLen Then dwg.AddLine x+16*chh,y-28*chh,x+(16*chh) + (maxLen * chb),y-28*chh,8,-1
		If optMatWeg Then
			dwg.AddLine x-8*chh,y-14*chh,x+8*chh,y-14*chh,8,-1
		End If
		If optNotBea Then
			dwg.AddCircle x,y-9.25*chh,4.5*chh,8,-1
		End If
	Else
		dwg.AddLine x-8*chh,y+14*chh,x,y,8,-1
		dwg.AddLine x+16*chh,y+28*chh,x,y,8,-1
		dwg.AddText x+16*chh,y+3*chh,txt2,8,-1
		dwg.AddText x +(5*chh) - (Len(txt1)*chb),y+16*chh,txt1,8,-1
	
		dwg.AddText x-(12*chh) - (Len(txtBeaZug)*chb),y+3*chh,txtBeaZug,8,-1
		dwg.AddText x+16*chh,y+30*chh,txtFerVer,8,-1
		dwg.AddText x+16*chh,y+15*chh,txtBezStr,8,-1
		If maxLen Then  dwg.AddLine x+16*chh,y+28*chh,x+(16*chh) + (maxLen * chb),y+28*chh,8,-1
		If optMatWeg Then
			dwg.AddLine x-8*chh,y+14*chh,x+8*chh,y+14*chh,8,-1
		End If
		If optNotBea Then
			dwg.AddCircle x,y+9.25*chh,4.5*chh,8,-1
		End If
	End If
End Sub

' procedura tworzy obiekt, rysuje grafik i umoliwia jego dowolne ustawienie
Private Sub DoIt
	Set doc = Application.ActiveDocument
	Set dwg = doc.Drawing
	Dim idx As Long
	idx = dwg.AddObject()  ' stwrz nowy obiekt, pobierz jego indeks
	If (idx > 0) Then
		dwg.OpenObject(idx)  ' otwrz obiekt, dodaj do niego grafik
		DrawSymbol dwg, 0, 0
		dwg.CloseObject()
		dwg.ExecuteString("SUW(mode=OSTOBI,p=[0,0])") ' gotowe, ustaw obiekt we waciwym miejscu
	End If
End Sub

' gwna procedura - tu makro startuje
Sub Main
	Dim txtAry(6) As String
	Dim txtRaw(9) As String
	Dim i As Integer

	txtAry(1) = "="
	txtAry(2) = "T"
	txtAry(3) = "X"
	txtAry(4) = "M"
	txtAry(5) = "C"
	txtAry(6) = "R"
	
		txtRaw(1)="" & "0.63"
		txtRaw(2)="" & "1.25"
		txtRaw(3)="" & "2.5"
		txtRaw(4)="" & "5"
		txtRaw(5)="" & "10"
		txtRaw(6)="" & "20"
		txtRaw(7)="" & "40"
		txtRaw(8)="" & "80"
		txtRaw(9)="" & "160"
	
	Begin Dialog UserDialog 530,203,"PN-ISO 1302 - Struktura geometryczna powierzchni"
		Text 7,5,119,15,"Warto w um",.Text2
		ComboBox 7,20,105,75,txtRaw(),.txt1
		Text 175,5,231,15,"Kierunkowo struktury pow.",.Text1
		ComboBox 175,20,105,75,txtAry(),.txt2
		Text 7,100,147,15,"Naddatek na obrbk",.Text3
		TextBox 161,95,119,20,.txtBeaZug
		Text 7,125,147,15,"Metoda wykonania",.Text4
		TextBox 161,120,119,20,.txtFerVer
		Text 7,150,147,15,"Wysoko falistoci",.Text5
		TextBox 161,145,119,20,.txtBezStr
		CheckBox 322,100,203,15,"Obrbka skrawaniem",.optMatWeg
		CheckBox 322,120,203,15,"Bez usuwania materiau",.optNotBea
		CheckBox 322,150,203,15,"Pozycja 'do gry nogami'",.optUpDwn
		OKButton 126,175,119,25,.fldOk
		PushButton 280,175,119,25,"&Anuluj",.cmdCancel
	End Dialog
	
	Dim dlg As UserDialog ' dialog uytkownika
	Dim result As Integer
	result = Dialog(dlg)  ' otwrz dialog
	txt1 = dlg.txt1
	txt2 = dlg.txt2
	txtBeaZug = dlg.txtBeaZug
	txtFerVer = dlg.txtFerVer
	txtBezStr = dlg.txtBezStr
	optMatWeg = dlg.optMatWeg
	optNotBea = dlg.optNotBea
	optUpDwn = dlg.optUpDwn
	Select Case result ' dialog zakoczono przyciskiem OK
		Case -1
			DoIt ' kontynuuj tworzenie symbolu
	End Select
End Sub

